VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "COMCTL32.OCX"
Begin VB.Form fTest 
   Caption         =   "Draw Edge Control Demonstration"
   ClientHeight    =   6375
   ClientLeft      =   2625
   ClientTop       =   2535
   ClientWidth     =   5025
   Icon            =   "fTest.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6375
   ScaleWidth      =   5025
   Begin TestDrawEdge.DrawEdgeDemo ctlEdges 
      Height          =   2295
      Left            =   120
      TabIndex        =   1
      Top             =   60
      Width           =   4635
      _ExtentX        =   5847
      _ExtentY        =   3096
   End
   Begin ComctlLib.TreeView tvwOptions 
      Height          =   3855
      Left            =   120
      TabIndex        =   0
      Top             =   2460
      Width           =   3975
      _ExtentX        =   7011
      _ExtentY        =   6800
      _Version        =   327682
      HideSelection   =   0   'False
      Indentation     =   441
      LabelEdit       =   1
      Style           =   5
      Appearance      =   1
   End
   Begin ComctlLib.ImageList ilsIcons 
      Left            =   4200
      Top             =   2460
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   327682
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   3
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fTest.frx":014A
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fTest.frx":0464
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fTest.frx":077E
            Key             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "fTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()

    ' Set up user control:
    With ctlEdges
        .BorderStyle(BDR_CONTROL) = True
        .BorderPart(BF_RECT) = True
    End With
    
    ' Set up options:
    Dim n1 As Node, n2 As Node
    With tvwOptions
        .ImageList = ilsIcons
        Set n1 = .Nodes.Add(, , "C" & BF_RECT, "Edge Rectangle", 1)
        Set n2 = .Nodes.Add(n1, tvwChild, "C" & BF_TOPLEFT, "Edge TopLeft", 1)
        .Nodes.Add n2, tvwChild, "C" & Bf_Top, "Edge Top", 1
        Set n2 = .Nodes.Add(n2, tvwChild, "C" & Bf_left, "Edge Left", 1)
        n2.EnsureVisible
        Set n2 = .Nodes.Add(n1, tvwChild, "C" & Bf_BOTTOMRIGHT, "Edge BottomRight", 1)
        .Nodes.Add n2, tvwChild, "C" & Bf_bottom, "Edge Bottom", 1
        Set n2 = .Nodes.Add(n2, tvwChild, "C" & Bf_right, "Edge Right", 1)
        n2.EnsureVisible
        Set n1 = .Nodes.Add(, , "F" & BDR_BUTTON, "ButtonBorder", 2)
        .Nodes.Add n1, tvwChild, "F" & BDR_RAISEDOUTER, "Raised Outer", 2
        Set n2 = .Nodes.Add(n1, tvwChild, "F" & BDR_RAISEDINNER, "Raised Inner", 2)
        n2.EnsureVisible
        Set n1 = .Nodes.Add(, , "F" & BDR_CONTROL, "ControlBorder", 1)
        .Nodes.Add n1, tvwChild, "F" & BDR_SUNKENOUTER, "Sunken Outer", 1
        Set n2 = .Nodes.Add(n1, tvwChild, "F" & BDR_SUNKENINNER, "Sunken Inner", 1)
        n2.EnsureVisible
        .Nodes.Add , , "F" & BF_SOFT, "Soft Edge", 2
        .Nodes.Add , , "F" & BF_FLAT, "Flat Edge", 2
        .Nodes.Add , , "F" & BF_MONO, "Monochrome Edge", 2
    End With
End Sub

Public Sub EvaluateOption()
Dim i As Long
Dim sKey As String
Dim LVal As Long
Dim bSet As Boolean
    
    For i = 1 To tvwOptions.Nodes.Count
        If (tvwOptions.Nodes(i).Children = 0) Then
            sKey = tvwOptions.Nodes(i).Key
            LVal = CLng(Mid$(sKey, 2))
            If (tvwOptions.Nodes(i).Image = 1) Then
                bSet = True
            Else
                bSet = False
            End If
            If (Left$(sKey, 1) = "F") Then
                ctlEdges.BorderStyle(LVal) = bSet
            Else
                ctlEdges.BorderPart(LVal) = bSet
            End If
        End If
    Next i
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    With ctlEdges
        .Move .Left, .Top, Me.ScaleWidth - .Left * 2, .Height
        tvwOptions.Move .Left, .Top * 2 + .Height, .Width, Me.ScaleHeight - .Top * 3 - .Height
    End With
End Sub

Private Sub tvwOptions_NodeClick(ByVal Node As ComctlLib.Node)
Dim iImage As Long
Dim iNewImage As Long
    iImage = Node.Image
    If (iImage = 1) Then
        iNewImage = 2
    Else
        iNewImage = 1
    End If
    Node.Image = iNewImage
    If (Node.Children > 0) Then
        SetLower Node.Child, iNewImage, False
    End If
    If Not (Node.Parent Is Nothing) Then
        SetHigher Node.Parent
    End If
    EvaluateOption
End Sub
Private Sub SetLower(ByRef nodX As Node, ByVal iImage As Long, ByVal bSiblings As Boolean)
Dim i As Long
    For i = nodX.FirstSibling.Index To nodX.LastSibling.Index
        If tvwOptions.Nodes(i).Children > 0 Then
            SetLower tvwOptions.Nodes(i).Child, iImage, True
        End If
        tvwOptions.Nodes(i).Image = iImage
    Next i
End Sub
Private Sub SetHigher(ByRef nodX As Node)
Dim i As Long
Dim bAllSelected As Boolean
Dim bAllDeSelected As Boolean
Dim nodC As Node
    
    bAllSelected = True
    bAllDeSelected = True
    Set nodC = nodX.Child
    For i = nodC.FirstSibling.Index To nodC.LastSibling.Index
        Select Case tvwOptions.Nodes(i).Image
        Case 1
            bAllDeSelected = False
        Case 2
            bAllSelected = False
        Case 3
            bAllDeSelected = False
            bAllSelected = False
        End Select
    Next i
    If (bAllSelected) Then
        nodX.Image = 1
    ElseIf (bAllDeSelected) Then
        nodX.Image = 2
    Else
        nodX.Image = 3
    End If
    If Not nodX.Parent Is Nothing Then
        SetHigher nodX.Parent
    End If

End Sub
